package com.ghjg.shoreline.Schedule;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ghjg.shoreline.dto.DredgingProjectShips;
import com.ghjg.shoreline.eum.ShipVideEnum;
import com.ghjg.shoreline.service.DredgingProjectShipsService;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

/**
 * @ClassName: DredgVideoIdSchedule
 * @description: TODO
 * @author: sbj
 * @time: 2023/12/6 17:13
 * @Version: 1.0
 */
@Component
public class DredgeVideoIdSchedule {

  @Autowired
  private DredgingProjectShipsService shipsService;

  //@Scheduled(cron = "0 0 3 * * ? ")
  @PostConstruct
  public void updateVideoIdSchedule(){
    List<String> dredgingImportRules =  shipsService.getAllProjectId();
    for (String dredgingImportRule : dredgingImportRules) {
      LambdaQueryWrapper<DredgingProjectShips> wrapper = Wrappers.<DredgingProjectShips>lambdaQuery()
          .eq(DredgingProjectShips::getOverviewId, dredgingImportRule);
      List<DredgingProjectShips> list = shipsService.list(wrapper);
      for (DredgingProjectShips ship : list) {
        for (ShipVideEnum value : ShipVideEnum.values()) {
          if (ship.getName().equals(value.getShipName())){
            ship.setVideoId(value.getVideoId());
            shipsService.updateVideoId(ship);
            break;
          }
        }
      }
    }
  }
}
