package com.ghjg.shoreline.service.impl;


import cn.hutool.core.lang.generator.SnowflakeGenerator;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ghjg.shoreline.dto.ShoreLineMangeFile;
import com.ghjg.shoreline.dto.ShorelineManage;
import com.ghjg.shoreline.dto.ShorelineManageHistory;
import com.ghjg.shoreline.mapper.ShoreLineMapper;
import com.ghjg.shoreline.service.ShoreLineHistoryService;
import com.ghjg.shoreline.service.ShoreLineService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ghjg.shoreline.service.ShoreLineMangeFileService;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@Service
@Slf4j
public class ShoreLineServiceImpl extends ServiceImpl<ShoreLineMapper, ShorelineManage> implements ShoreLineService {
    @Resource
    private ShoreLineMapper shoreLineMapper;
    @Autowired
    private ShoreLineHistoryService shoreLineHistoryService;
    @Autowired
    private ShoreLineMangeFileService fileService;

    @Override
    public void updateAllThreeTable() {
        List<ShorelineManage> passDateList = shoreLineMapper.getPassDateList();
        if (passDateList.isEmpty()) {
            log.info("无需要更新的内容");
        } else {
            ArrayList<ShorelineManageHistory> shorelineManageHistories = new ArrayList<>();
            ArrayList<ShoreLineMangeFile> shoreLineMangeFiles = new ArrayList<>();
            for (ShorelineManage shorelineManage : passDateList) {
                String lastId = shorelineManage.getId();
                //先留存历史数据
                ShorelineManageHistory shorelineManageHistory = new ShorelineManageHistory();
                BeanUtils.copyProperties(shorelineManage, shorelineManageHistory);
                shorelineManageHistory.setUpdateUser("5043");
                shorelineManageHistory.setKeyId(UUID.randomUUID().toString().replace("-",""));
                shorelineManageHistories.add(shorelineManageHistory);

                //更新现有数据
                shorelineManage.setIsUpdate(1);
                shorelineManage.setCertificationStatus("已过期");
                shorelineManage.setUpdateUser("5043");
                shorelineManage.setId(UUID.randomUUID().toString().replace("-",""));

                //文件
                List<ShoreLineMangeFile> files = fileService.list(Wrappers.<ShoreLineMangeFile>lambdaQuery().eq(ShoreLineMangeFile::getCoId, lastId));
                if (!files.isEmpty()){
                    //文件不空
                    for (ShoreLineMangeFile file : files) {
                        ShoreLineMangeFile shoreLineMangeFile = new ShoreLineMangeFile();
                        BeanUtils.copyProperties(file,shoreLineMangeFile);
                        shoreLineMangeFile.setCoId(shorelineManage.getId());
                        shoreLineMangeFile.setId(new SnowflakeGenerator().next().toString());
                        shoreLineMangeFiles.add(shoreLineMangeFile);
                    }
                }
            }
            this.updateBatchById(passDateList);
            shoreLineHistoryService.saveBatch(shorelineManageHistories);
            fileService.saveBatch(shoreLineMangeFiles);
        }
    }
}
